<script lang="ts" setup>
import { useI18n } from 'vue-i18n';
import { ref, watch } from 'vue';

const limit = 9;
const skip = ref(0);
const currentPage = ref(1);

const allPosts = ref([]);
const posts = ref([]);
const totalPosts = ref(0);
const authorContent = ref(null);

const { content: authorPage } = defineProps({
  content: {
    type: Object as never,
    required: true,
  },
});

const { locale } = useI18n();

const { data } = await useAsyncData(async () => {
  const response = await queryContent(locale.value, '/blog')
    .where({
      'content.authors': { $contains: authorPage.name },
    })
    .sort({ 'content.date': -1 })
    .find();
  return {
    allPosts: response,
  };
});

allPosts.value = data.value?.allPosts || [];
totalPosts.value = allPosts.value.length;
posts.value = allPosts.value.slice(0, limit);
const meta = {
  title: `${authorPage?.name} | GitLab`,
  description: `Browse articles authored by ${authorPage?.name}`,
};
useGitlabSeo(meta);

function updateContent() {
  try {
    if (!authorPage) {
      authorContent.value = null;
      return;
    }

    const socialsBuild = {
      twitter: authorPage?.config.twitter,
      linkedin: authorPage?.config.linkedin,
      facebook: authorPage?.config.facebook,
      hackerNews: authorPage?.config.hackerNews,
      threads: authorPage?.config.threads,
    };

    const socials = Object.fromEntries(Object.entries(socialsBuild).filter(([_, v]) => v != null));
    const hasSocials = Object.keys(socials).length;
    const tabs = [
      {
        header: 'Articles',
        posts: posts.value,
      },
    ];

    if (hasSocials || authorPage?.bio) {
      tabs.push({
        header: 'About',
        bio: authorPage?.bio,
        socials: hasSocials && socials,
      });
    }

    authorContent.value = {
      author: authorPage,
      tabs,
    };
  } catch (error) {
    console.error('error updating author content', error);
  }
}

// Watch dependencies to update content dynamically
watch([posts], updateContent, { immediate: true });

const pagination = {
  totalPosts: totalPosts.value,
  total: Math.ceil(totalPosts.value / limit),
  currentPage: currentPage.value,
  perPage: limit,
};
function onPageChange(page) {
  currentPage.value = page;
  skip.value = limit * (page - 1);
  posts.value = allPosts.value.slice(skip.value, skip.value + limit);
  pagination.currentPage = page;
}
</script>

<template>
  <div v-if="authorContent" ref="targetRef">
    <BlogAuthorHero :author="authorContent.author" />
    <BlogAuthorTabs
      :tabs="authorContent.tabs"
      :author="authorContent.author"
      :pagination="pagination"
      @page-change="onPageChange"
    />
    <BlogHomeNewsletterForm />
    <CommonGetStarted background-class="half-purple" />
  </div>
</template>

<style scoped>
.slp-mt-64 {
  margin-top: 64px;
}
</style>
